/************************************************************************
 *	@file			PacManDemo/XKPacMaze.h
 *	@brief			Ϸ硪Maze
 *
 *	@author			Xiong Xinke
 *	@copyright		Xiong Xinke
 *	@date			2005-2-22 10:58:51
 ************************************************************************/
#ifndef __PACMANDEMO_XKPACMAZE_H__
#define __PACMANDEMO_XKPACMAZE_H__

#include <d3dx8.h>
#include <windows.h>
#include "XKSprite.h"

#pragma warning(disable : 4786)

//ԹTILE

enum MAZE_TILE_TYPE
{
	TILE_BLOCK= 0x00,	//ǽͨtile
	TILE_BLANK = 0x01, //·ͨtile
	TILE_ITEM = 0x02,  //Ʒǡӡ
	TILE_POWERUP = 0x03	//playerܹ֮Եghost
};

//playerghostƶ
enum RUSH_DIR
{
	DIR_NONE ,
	DIR_UP,
	DIR_DOWN,
	DIR_LEFT,
	DIR_RIGHT
};

const POINT MAZE_SIZE = {20,15};// maze size, x and y
const int	TILE_SIZE = 40;		//ÿשĴСשһ							// block size

class XKPacMaze  
{
public:
	bool IsBlock( const POINT& Pos , RUSH_DIR dir );
	XKPacMaze();
	virtual ~XKPacMaze();

	D3DXVECTOR2	ToTranslation( const POINT& Pos );					// convert position (tile) to translation
	POINT		ToPosition( const D3DXVECTOR2& vTranslation );					// convert transltion to position
	POINT		ToAdjacentPosition( POINT Pos , RUSH_DIR dir );	// convert position to adjacent position
	D3DXVECTOR2 GetPlayerTranslation();						// returns hero's last translation (acquired from updateitems)
	POINT		GetPlayerPosition();							// returns hero's last position

	void		UpdateItems( const D3DXVECTOR2& vPlayerTranslation );			// eat items and what not.
	void		Render2D();									// render the maze
	bool		IsCenteredOnTile( const D3DXVECTOR2& vTranslation );		// returns true if the translation is centered on the tile
	bool		IsCenteredOnTileX( const D3DXVECTOR2& vTranslation );	// true if centered on x
	bool		IsCenteredOnTileY( const D3DXVECTOR2& vTranslation );	// true if centered on y

private:
	unsigned char*	m_pMap;			//pointer to the current map
	int				m_nNumItems;	//ʣµĶӵĿΪ0ʱʾ
	XKSprite*		m_pTiles;
	D3DXVECTOR2		m_vPlayerTranslation ;//playerƽ
};

#endif /* __PACMANDEMO_XKPACMAZE_H__ */
