/************************************************************************
 *	@file			PacManDemo/XKSprite.h
 *	@brief			
 *
 *	@author			Xiong Xinke
 *	@copyright		Xiong Xinke
 *	@date			2005-2-22 16:20:29
 ************************************************************************/
#ifndef __PACMANDEMO_XKSPRITE_H__
#define __PACMANDEMO_XKSPRITE_H__

#include "XKTexture.h"
#include <d3dx8.h>

#pragma warning(disable : 4786)

class XKSprite  
{
public:
	XKSprite( ID3DXSprite* pSpr , XKTexture* pTex );
	XKSprite( ID3DXSprite* pSpr  , const string& FileName, 
			  D3DCOLOR ColorKey = NULL);
	virtual ~XKSprite();
	void SetSpriteTexture( XKTexture* pTex );
	void SetAnimationParams( int TotalAnim , int Rows , int Columns );
	
	void Render2D(const D3DXVECTOR2& translation = D3DXVECTOR2(0,0), 
				  const D3DXVECTOR2& rotCenter = D3DXVECTOR2(0,0), 
				  const float& rotation = 0,
				  const D3DXVECTOR2& scaling = D3DXVECTOR2(1,1),
				  D3DCOLOR color = D3DCOLOR_ARGB(255,255,255,255));
	void SetAnimation(int frame);
	XKTexture* GetXKTexture();
private:
	void Init();
	void InitAnimation();
	void UpdateRect();
	
protected:
	ID3DXSprite* m_pSprite;
	XKTexture*	 m_pTexture;		//sprite
	int          m_nWidth;			//spriteĸ߶
	int          m_nHeight;			//spriteĸ߶
	int          m_nRows;			//sprite֡
	int          m_nColumns;		//sprite֡
	int          m_nTotalAnim;		//жĸ
	int          m_nCurrentAnim;	//ǰҪȾĶ֡
	D3DCOLOR	 m_ColorKey;		//͸ɫ
	RECT         m_Rect;			//spriteİ
	bool		 m_bCreateTexture;	//spriteɹʱΪtrue
	static D3DCOLOR m_sDefaultColorKey;
};

#endif /* __PACMANDEMO_XKSPRITE_H__ */
