/************************************************************************
 *	@file			PacManDemo/XKTexture.cpp
 *	@brief			
 *
 *	@author			Xiong Xinke
 *	@copyright		Xiong Xinke
 *	@date			2005-2-22 13:34:02
 ************************************************************************/
#include "XKTexture.h"


TexInfoMap XKTexture::m_sInfoMap;

/**
 * @name  XKTexture::XKTexture
 * @brief     
 * @return    
 * @param     LPDIRECT3DDEVICE8 pDevice
 * @remark    
 **/
XKTexture::XKTexture( LPDIRECT3DDEVICE8 pDevice )
{
	m_pDevice = pDevice;
}

/**
 * @name  XKTexture::~XKTexture
 * @brief     
 * @return    
 * @remark    
 **/
XKTexture::~XKTexture()
{
	--(m_sInfoMap[m_strFileName].nCount);
}

/**
 * @name  XKTexture::CreateTexture
 * @brief     ָĿ͸ߴһհ׵
 * @return    
 * @param     const string& savFile
 * @param     int width
 * @param     int height
 * @remark    
 **/
void XKTexture::CreateTexture( const string& savFile , int width, int height )
{
	m_bMultiLevel = false;
	
	//ҪtextureǷѾload
	if( m_sInfoMap.size() )
	{
		if( m_sInfoMap.find( savFile) != m_sInfoMap.end() )
		{
			XKTexInfo tmp = m_sInfoMap[savFile];

			//Ѿ룬ȴòͬĸߣǲ
			//ٴ룬Ҫ׳һ쳣
			if( m_bMultiLevel != tmp.bMultiLevel ||
				m_nWidth != width || m_nHeight != height )
			{
				//׳쳣
			}

			//Ϲ룬Ͷüһ
			m_pTexture = m_sInfoMap[savFile].pTexture;
			++(m_sInfoMap[savFile].nCount);
			return;
		}
	}
	
	//textureûбload½һ
	XKTexInfo	info;
	HRESULT hr = D3DXCreateTexture( m_pDevice , 
		height , width , 0, D3DX_DEFAULT, D3DFMT_A8R8G8B8,
		D3DPOOL_MANAGED, &(info.pTexture));
	if( FAILED(hr) )
	{
		//׳쳣
	}
	
	info.nCount = 1;
	info.bMultiLevel = m_bMultiLevel;
	info.ImageInfo.Height = height;
	info.ImageInfo.Width = width;
	info.ColorKey = NULL;
	
	m_pTexture = info.pTexture;
	m_sInfoMap[savFile] = info;
	m_pPixels = NULL;
	
}

/**
 * @name  XKTexture::CreateTexture
 * @brief    ļݴһ
 * @return    
 * @param     const string& FileName
 * @param     bool bMultiLevel			Ƿʹmipmap
 * @param     D3DCOLOR ColorKey
 * @remark    
 **/
void XKTexture::CreateTexture( const string& FileName , bool bMultiLevel, D3DCOLOR ColorKey )
{
	m_bMultiLevel = bMultiLevel;
	m_strFileName = FileName;
	m_pTexture = NULL;

	//ҪtextureǷѾload
	if( m_sInfoMap.size() )
	{
		if( m_sInfoMap.find( FileName) != m_sInfoMap.end() )
		{
			XKTexInfo tmp = m_sInfoMap[FileName];

			//Ѿ룬ȴòͬĸߣǲ
			//ٴ룬Ҫ׳һ쳣
			if( m_bMultiLevel != tmp.bMultiLevel ||
				m_sInfoMap[FileName].ColorKey != ColorKey )
			{
				//׳쳣
			}

			//Ϲ룬Ͷüһ
			m_pTexture = m_sInfoMap[FileName].pTexture;
			++(m_sInfoMap[FileName].nCount);
			return;
		}
	}

	HRESULT		hr;
	XKTexInfo	info;

	//ʹö༶ˣmipmap
	if( bMultiLevel )
	{
		//filterΪD3DX_DEFAULTD3DX_FILTER_TRIANGLE | D3DX_FILTER_DITHER
		hr = D3DXCreateTextureFromFileEx( m_pDevice, FileName.c_str(), 
				0, 0, D3DX_DEFAULT, 0, D3DFMT_A8R8G8B8, 
				D3DPOOL_MANAGED, D3DX_DEFAULT, D3DX_DEFAULT, 
				ColorKey, &(info.ImageInfo), NULL, &(info.pTexture));
	}
	else
	{
		//filterΪD3DX_DEFAULT,ʹù
		hr = D3DXCreateTextureFromFileEx( m_pDevice, FileName.c_str(), 
				0, 0, D3DX_DEFAULT, 0, D3DFMT_A8R8G8B8, 
				D3DPOOL_MANAGED, D3DX_FILTER_NONE, D3DX_DEFAULT, 
				ColorKey, &(info.ImageInfo), NULL, &(info.pTexture));
	}

	if( FAILED(hr) )
	{
		//׳쳣
	}
	
	info.nCount = 1;
	info.bMultiLevel = m_bMultiLevel;
	m_nHeight =  info.ImageInfo.Height;
	m_nWidth = info.ImageInfo.Width;
	info.ColorKey = NULL;
	
	m_pTexture = info.pTexture;
	m_sInfoMap[FileName] = info;
	m_pPixels = NULL;
}

/**
 * @name  XKTexture::GetHeight
 * @brief     ĸ߶ȣΪλ
 * @return    int 
 * @remark    
 **/
int XKTexture::GetHeight()
{
	return m_sInfoMap[m_strFileName].ImageInfo.Height;
}

/**
 * @name  XKTexture::GetWidth
 * @brief     ĿȣΪλ
 * @return    int 
 * @remark    
 **/
int XKTexture::GetWidth()
{
	return m_sInfoMap[m_strFileName].ImageInfo.Width;
}

/**
 * @name  XKTexture::BeginDrawing
 * @brief     ڿʼʱһЩԤȲ
 * @return    void 
 * @remark    
 **/
void XKTexture::BeginDrawing()
{
	if( m_bMultiLevel )
	{
		//׳쳣
	}

	//
	ZeroMemory( &m_LockRect , sizeof(D3DLOCKED_RECT));
	HRESULT hr = m_pTexture->LockRect( 0 , 
				 &m_LockRect , NULL , 0 );
	
	if( FAILED(hr) )
	{
		//׳쳣
	}
	//ľȡȺָ
	m_dwPitch = m_LockRect.Pitch; 
	m_pPixels = (unsigned char*)m_LockRect.pBits;
}

/**
 * @name  XKTexture::EndDrawing
 * @brief     ڽʱһЩβ
 * @return    void 
 * @remark    
 **/
void XKTexture::EndDrawing()
{
	if( m_bMultiLevel )
	{
		//׳쳣
	}

	m_pTexture->UnlockRect(0);
	m_dwPitch = 0;
	m_pPixels = NULL;
}

/**
 * @name  XKTexture::GetFileName
 * @brief     
 * @return    string 
 * @remark    
 **/
string XKTexture::GetFileName()
{
	return m_strFileName;
}

/**
 * @name  XKTexture::GetTexture
 * @brief     
 * @return    LPDIRECT3DTEXTURE8 
 * @remark    
 **/
LPDIRECT3DTEXTURE8 XKTexture::GetTexture()
{
	return m_pTexture;
}
